function [x,t] = bdf3_gbo(t0,tf,x0,x1,x2,h)
	n = floor((tf - t0)/h);
	[r,m] = size(x0);

	t = zeros(n+1,1); x = zeros(n+1,m);
	t(1) = t0; t(2) = t0 + h;
	x(1,:) = x0; x(2,:) = x1; x(3,:) = x2;
	xkm2 = x0;
	xkm1 = x1;
	xk = x2;
	tkp1 = t0 + 2.0*h;

	for k=3:n

        % berechne Nullstelle von bdf2step_f
        % und nehme x_{k} als Startnaeherung:

		fun = @(x)bdf3step_fo(x,xk,xkm1,xkm2,tkp1,h);

        xkp1 = fsolve(fun,xk);
        t(k+1) = tkp1;   % speichere Zeitpunkt t_{k+1}
        x(k+1,:) = xkp1; % speichere Loesung x_{k+1}
        tkp1 = tkp1+h;   % update t_{k+1} fuer naechsten Schritt
	    xkm2 = xkm1;	 % update x_{k-2} fuer naechsten Schritt
        xkm1 = xk;       % update x_{k-1} fuer naechsten Schritt
        xk = xkp1;       % update x_{k} fuer naechsten Schritt
    end
end
