% Programm 3.2 zur Bestimmung der Bestapproximation x
% zur Behandlung des ueberbestimmten Systems C x = y
% unter Nutzung der im Programm 3.1 (qr_gb.m)  erzeugten 
% Matrix c = (c(ij)) und dem Vektor t(i) (QR-Zerlegung)
% input:  Matrix c, Vektor t als Ergebnis des Programms qr_gb,
%         Vektor y als rechte Seite
% output: Loesung x, Residuenvektor d
% Aufruf: [x,d] = bestapprqr_gb1(c,t,y);
function [x,d] = bestapprqr_gb1(c,t,y);
m = length(c(:,1));
p = length(c(1,:));
% Aufbau der rechten Seite Q^T y
for l=1:p
  summe = c(l:m,l)'*y(l:m);
  summe = summe + summe;
  for k=l:m
    y(k) = y(k) - summe*c(k,l);
  end
end
% Loesung des Gleichungssystems $ R x = Q^T y
for i=p:-1:1
  summe = y(i);
  d(i) = 0;
  if ((i+1)<= p)
	for k=i+1:p
		summe = summe - c(i,k)*x(k);
    end
  end
  x(i) = summe/t(i);
end
if ((p+1)<= m)
	d(p+1:m) = y(p+1:m);
endif
% Ruecktransformation des Residuums
for l=p:-1:1
	summe = c(l:m,l)'*d(l:m)';
	summe = summe + summe;
	for k=l:m
		d(k) = d(k) - summe*c(k,l);
	end
end
x=x';
d=d';
end
