% Programm 10.3: euler_maruyama_gb.m ; Euler-Maruyama-Verfahren 
% lineare SDE  dX = lambda*X dt + mu*X dW, X(0) = Xzero
% lambda = 2, mu = 1 und Xzero = 1
%
% Approximation des Wiener-Prozesses auf einem Gitter [0,1] mit dt = 2^(-8)
% beim Euler-Maruyama-Verfahren werden groessere Zeitschritte benutzt: R*dt 
randn('state',100) % random seeding
lambda = 2 ; mu = 1 ; Xzero = 1 ; % Parameter des Problems
T = 1 ; N = 2^8 ; dt = 1/N;
dW = zeros(1,N); W = zeros(1,N); Xtrue = zeros(1,N); % Pre-Allokierung
dW = sqrt(dt)*randn(1,N) ; % Inkremente des Wiener-Prozesses
W = cumsum(dW) ; % approximierter Pfad eines Wiener-Prozess
Xtrue = Xzero*exp((lambda -0.5*mu^2)*([dt:dt:T])+mu*W) ; % exakte Loesung
plot([0:dt:T],[Xzero,Xtrue],'g-'), hold on
R = 4 ; Dt = R*dt ; L = N/R; % L Euler-Maruyama Schwritte mit Dt = R*dt
Xem = zeros(1,L) ; % Pre-Allokierung
Xtemp = Xzero ;
for j = 1:L
   Winc = sum(dW(R*(j-1)+1:R*j)) ; 
   Xtemp = Xtemp + Dt*lambda*Xtemp + mu*Xtemp*Winc ;
   Xem(j) = Xtemp ;
end
plot([0:Dt:T],[Xzero,Xem],'r--*'), hold off
xlabel('t','FontSize',12)
ylabel('X','FontSize',16,'HorizontalAlignment','right')
emerr = abs(Xem(end)-Xtrue(end))
% Programmende
