% Programm 7.5 zur Gauss-Seidel-Iteration (gaussseidelit_gb.m)
% input:  Diagonalen l,d,u der Koeffizientenmatrix a, l(1) und u(n) sind dummy-Werte
%         rechte Seite b
% output: Loesung x
% Aufruf: [x] = gaussseidelit_gb0(l,d,u,b)
function [x] = gaussseidelit_gb0(l,d,u,b);
xdiff = 1; xnorm = 1; it = 0;
n = length(d);
x(1:n) = 0.0;
while (sqrt(xdiff/xnorm) > 10^(-10))
   xalt = x;
   x(1) = (b(1) - u(1)*x(2))/d(1);
   for i=2:n-1
      x(i) = (b(i) - l(i)*x(i-1) - u(i)*x(i+1))/d(i);
   end
   x(n) = (b(n) - l(n)*x(n-1))/d(n);
   xdiff = 0; xnorm = 0;
   for i=1:n
      xdiff = xdiff + (x(i)-xalt(i))^2;
      xnorm = xnorm + xalt(i)^2;
   end
   if (xnorm == 0)
      xnorm = 1;
   end
   it = it + 1;
end
it
end
