% Programm 4.1 zur Transfomation von a auf Hessenberg-Form
% input:  Matrix a=(a_{ij}) vom Typ n x n
% output: Hessenberg-Matrix h, orthogonale Matrix q^T
% Aufruf: [h,qt] = hessenberg_gb2(a)
% Endergebnis [H|Q^T]
function [h,qt] = hessenberg_gb2(a);
n = length(a(:,1));
% Aufbau des erweiterten Schemas [A|E]
E = eye(n);
a = [a E];
% Erzeugung des unteren Null-Dreiecks
for j=1:n-2
   summe = a(j+1:n,j)'*a(j+1:n,j);
   c = sign(a(j+1,j))*sqrt(summe);
   if (c ~= 0)
      a(j+1,j)=c+a(j+1,j);
      d=1/(c*a(j+1,j));
% Linksmultiplikation mit H_j
      for k=j+1:2*n
		 summe = a(j+1:n,j)'*a(j+1:n,k);
         e=d*summe;
		 a(j+1:n,k) = a(j+1:n,k)-e*a(j+1:n,j);
      end
% Rechtsmultiplikation mit H_j
      for i=1:n
		 summe = a(i,j+1:n)*a(j+1:n,j);
         e=d*summe;
	     a(i,j+1:n) = a(i,j+1:n)-e*a(j+1:n,j)'; 
      end
% update von a(j+1,j)...a(n,j)
      a(j+1,j)=-c;
      a(j+2:n,j) = 0;
   end
end
h = a(1:n,1:n);
qt = a(1:n,n+1:n+n);
end
