% Programm 5.1 Lagrange-Interpolation
% Berechnung des Polynomwerts p_n(xx) des Lagrange-Polynoms
% fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
% input:  Vektoren x(1:n+1), y(1:n+1), Stelle xx
% output: Polynomwert p_n(xx)
% Aufruf: [fwert] = lagrangeip_gb1(xx,x,y);
function [fwert] = lagrangeip_gb1(xx,x,y);
n=length(x)-1;
% Konstruktion der Lagrange-Basispoylnome l_0,l_1,...,l_n
% bei den Stuetzwerten x_0,x_1,...,x_n (=Vektor x(1:n+1)) 
% an der Stelle xx
for k=0:n
  faktor=1;
  for i=0:n
    if (i ~= k)
      faktor=faktor*(xx-x(i+1))/(x(k+1)-x(i+1));
    end
  end
  l(k+1)=faktor;
end
% Polynomwertberechnung p_n(xx)
% bei den Werten y_0,y_1,...,y_n (=Vektor y(1:n+1))
fwert = l(1:n+1)*y(1:n+1)';
end
