% Programm 2.1 zur LR-Zerlegung einer Matrix A
% input:  Matrix a0
% output: Matrix a, enthaelt im oberen Dreieck die Matrix R
%         und unterhalb der Hauptdiagonale die Matrix L       
%         Buchhaltungsvektor z der Zeilenvertauschungen,
%         output ist input fuer das Programm lrloes_gb
% Aufruf: [a,z] = lr_gb1(a0);
function [a,z] = lr_gb1(a0);
a=a0;
n = length(a(:,1));
z = linspace(1,n,n)';
% z = zeros(n,1);
% Initialisierung eines Zeilenvertauschungsvektors
% for i=1:n
%   z(i)=i;
% end
% Rueckspeicherung der Matrix
a0 = a;
% Elimination
for j=1:n-1
% Pivotsuche
  apivot=abs(a(j,j));
  p=j;
  for l=j+1:n
    if (abs(a(l,j)) > abs(apivot))
      apivot=a(l,j);
      p=l;
    end
  end
  if (apivot ~= 0)
% Vertauschung der Zeilen j und p
    for i=1:n
      c=a(j,i);
      a(j,i)=a(p,i);
      a(p,i)=c;
    end
    pp=z(j);
    z(j)=z(p);
    z(p)=pp;
% Elimination
    for i=j+1:n
      a(i,j)=a(i,j)/a(j,j);
      for k=j+1:n
        a(i,k)=a(i,k)-a(i,j)*a(j,k);
      end
    end
  end
end
%
idet = 1;
for j=1:n
  if (abs(a(j,j)) < 1.0e-10)
    idet = 0;
  end
end
if (idet == 0)
  disp('Matrix singulaer, lrloes_gb nicht anwendbar');
end
end
