% Loesung der Schwingungsgleichung x'' + sin(x) = 0, x(0) = 1, x'(0) = 0
% Vergleich mit der exakten Loesung von der Approximationx'' + x = 0
% BDF3-Verfahren, verwendete Programme: bdf3_gbo.m, bdf3step_fo.m, fo.m

t0 = 0;
tf = 2*pi;
h = 1e-2;
x0 = [1.0,0.0];
x1 = [cos(h),sin(h)];
%x2 = [cos(2*h),sin(2*h)];
x2 = x1;

[x,t] = bdf3_gbo(t0,tf,x0,x1,x2,h);

% berechne exakte Loesung unter der Annahme sin(x) ~ x fuer kleine x-Werte
nn = size(t);
xx = ones(nn,size(x0));
xx(:,1) = cos(t(:));
xx(:,2) = -sin(t(:));

%for i=1:nn(1)
%	xx(i,1) = cos(t(i));
%	xx(i,2) = -sin(t(i));
%end

% graphische Darstellung der numerischen Loesung

figure(1)
plot(t, x(:,1), "-b", 'linewidth',2.5, t, xx(:,1), "-r", 'linewidth',2.5)
legend("num. Loesung","ex. Loesung")
legend("boxoff")
tt = "Loesungen (BDF3)"
nt = title(tt)
set(nt,'FontSize',14)
%title("Loesungen")
%
% Plot der Ableitungen
figure(2)
plot(t, x(:,2), "-b", 'linewidth',2.5, t, xx(:,2), "-r", 'linewidth',2.5)
legend("num. Loesung","ex. Loesung")
legend("boxoff")
tt = "Ableitung der Loesungen (BDF3)"
nt = title(tt)
set(nt,'FontSize',14)
%title("Ableitung der Loesungen")
