% Programm 8.2a, BDF-2-Verfahren
function fs = fo(y,x,t)
	fs(1) = y(1) - x(2);
	fs(2) = y(2) + sin(x(1));
end
function fbdf = bdf2step_fo(x,xk,xkm1,tkp1,h)
	ykp1 = (1.5*x - 2.0*xk + 0.5*xkm1)/h;
	fbdf = fo(ykp1,x,tkp1);
end
function [x,t] = bdf2_gbo(t0,tf,x0,x1,h)
n = floor((tf - t0)/h);
[r,m] = size(x0);
t = zeros(n+1,1); x = zeros(n+1,m);
t(1) = t0; t(2) = t0 + h;
x(1,:) = x0; x(2,:) = x1;
xkm1 = x0; xk = x1; tkp1 = t0 + 2.0*h;
for k=2:n 
	fun = @(x)bdf2step_fo(x,xk,xkm1,tkp1,h);
	xkp1 = fsolve(fun,xk); % best. Nullst. v. bdf2step_fo (x_{k} Startnaeherung)
	t(k+1) = tkp1;   % speichere Zeitpunkt t_{k+1}
	x(k+1,:) = xkp1; % speichere Loesung x_{k+1}
	tkp1 = tkp1+h;   % update t_{k+1} fuer naechsten Schritt
	xkm1 = xk;       % update x_{k-1} fuer naechsten Schritt
	xk = xkp1;       % update x_{k} fuer naechsten Schritt
end
end

% Loesung der Schwingungsgleichung x'' + sin(x) = 0, x(0) = 1, x'(0) = 0
% Vergleich mit der exakten Loesung von der Approximation x'' + x = 0
% BDF2-Verfahren, verwendete Programme: bdf2_gbo.m, bdf2step_fo.m, f0.m
t0 = 0; tf = 2*pi; h = 1e-2;
x0 = [1.0,0.0]; x1 = [cos(h),sin(h)];
[x,t] = bdf2_gbo(t0,tf,x0,x1,h);
% berechne exakte Loesung unter der Annahme sin(x) ~ x fuer kleine x-Werte
nn = size(t); xx = ones(nn);
xx(:,1) = cos(t(:));
xx(:,2) = -sin(t(:));

