% Programm 9.3 zur Loesung eines Anfangs-Randwertproblems (parapde_gb.m)
%  u_t - u_xx = 5x(1-x), 0<x<1, 0<t <=10, u(0,t)=u(1,t)=0, u(x,0)=sin(2x\pi)
% mit der FEM (raeumlich, stueckweise lineare Elemente), 
% Zeitintegration: Euler-rueckwaerts
% n=21, h=1/21, tau=0,1, m=10/tau Zeitschrittzahl
% input:
% output: Loesung yp(x,t) auf dem Raum-Zeit-Gitter x1,x2
% Aufruf: [yp,x1,x2] = parapde_gb0;
function [yp,x1,x2] = parapde_gb0;
r = zeros(20,1); r0= zeros(20,1);
h=1/21; tau =0.1; m=10/tau;
for i=1:20
  x(i)=i*h;
end
amasse = zeros(20,20); asteif = zeros(20,20);
for i=1:20
  amasse(i,i)=4; asteif(i,i)=2;
end
for i=1:19
  amasse(i+1,i)=1; amasse(i,i+1)=1;
  asteif(i,i+1)=-1; asteif(i+1,i)=-1; 
end
amasse = (h/6)*amasse; asteif = (1/h)*asteif;
for i=1:20
  r(i) = 5*x(i)*(1-x(i))*h/2; r0(i)= sin(x(i)*2*pi)*h/2;
end
%
ams = amasse\asteif;
rm = amasse\r;
y0 = amasse\r0;
mit = (1/tau)*eye(20)+ams;
% Euler-Verfahren
yn = y0;
for i=1:m
  yn = mit\(yn/tau+rm);
  y(:,i) = yn;
end
% Aufbereitung der Ergebnisse fuer die Grafik
yp = zeros(22,m+1);
yp(2:21,1)=y0; yp(2:21,2:m+1)=y;
x1=zeros(22,1);
x1(2:21)=x; x1(22)=x1(21)+h;
for j=1:m+1
  x2(j)=(j-1)*tau;
end
end
