% Programm 3.1 zur QR-Zerlegung einer Matrix c0 = q*r
% Erzeugung der wesentlichen Informationen fuer 
% die orthogonale Matrix Q und der oberen Dreiecksmatrix R
% input:  Matrix c0=(c0(ij)) vom Typ m x p gegeben (m >= p)
% output: Matrix c mit den wesentlichen Informationen
%         der orthogonalen Matrix q und der oberen Dreiecksmatrix r,
%         Vektor t mit den ersten Nichtnull-Komponenten von q1,q2,...
%         Erzeugung des inputs fuer das Programm bestapprqr_gb.m,
% Aufruf: [c,t] = qr_gb1(c0);
function [c,t] = qr_gb1(c0);
c=c0;
m = length(c(:,1));
p = length(c(1,:));
for l=1:p
  gamma = c(l:m,l)'*c(l:m,l);
  gamma = sqrt(gamma);
  if (c(l,l) < 0)
    gamma = -gamma;
  end
  peta=sqrt(2*gamma*(gamma+c(l,l)));
  t(l) = -gamma;
  c(l,l) = (c(l,l)+gamma)/peta;
  c(l+1:m,l) = c(l+1:m,l)/peta;
  for j=l+1:p
    g = c(l:m,l)'*c(l:m,j);
    g = g + g;
	c(l:m,j) = c(l:m,j) - g*c(l:m,l);
  end
end
end
