% Hauptprogramm zur Ausfuehrung von radauIIA_gb

t0 = 0.0; tf = 1e-2; h = 1e-5;

C  = 1.5e-14; % Kapazitaet
iS = 1e-12; % Sperrsaettigungsstrom
uT = 25e-3; % Temperaturspannung
u_input = 5.0; % Spannung der Spannungsquelle

% Startwert x0:
x0 = zeros(3,1);
x0(1) = 4.5;
x0(2) = u_input;
x0(3) = iS*(exp((x0(1)-x0(2))/uT)-1.0)

parameter = [C,iS,uT,u_input];

[x, t] = radauIIA_gb(t0,tf,x0,h,"classic",parameter);
    
figure(1)
plot(t,x(:,1))
xlabel('t')
ylabel('x1')
title("radauIIA-Schaltungs-DAE, x1")

figure(2)
plot(t,x(:,2))
xlabel('t')
ylabel('x2')
title("radauIIA-Schaltungs-DAE, x2")

figure(3)
plot(t,x(:,3))
xlabel('t')
ylabel('x3')
title("radauIIA-Schaltungs-DAE, x3")

%    % graphische Darstellung der numerischen Loesung
%    fig, axes = plt.subplots(1, 3, figsize=(18,4))
%    for i in range(3):
%        axes[i].plot(t, x[:,i], color="blue", linewidth=2,linestyle="-")
%        axes[i].set_xlabel('t')
%        axes[i].set_ylabel('x'+str(i+1))

%    plt.savefig("radauIIA_Schaltungs_DAE.png",dpi=300, bbox_inches='tight')
%    plt.show()

