% Die Stufenloesung X=(X1,X2) eines Radau-IIA-Schrittes
% ist Nullstelle von radauIIA_step_gb (nahe (x_k,x_k)).
function FF = radauIIA_step_gb(X,xk,tk,h,daetype,parameter,m,a1,a2,beta11,beta12,beta21,beta22)
X1 = X(1:m);
X2 = X(m+1:2*m);
dX1 = radauIIA_ddae_gb(X1,tk+a1*h,daetype,parameter);
dX2 = radauIIA_ddae_gb(X2,tk+a2*h,daetype,parameter);
dxk = radauIIA_ddae_gb(xk,tk,daetype,parameter);
Y1 = (beta11*(dX1-dxk) + beta12*(dX2-dxk))/h;
Y2 = (beta21*(dX1-dxk) + beta22*(dX2-dxk))/h;
[f1,f2,f3] = radauIIA_fdae_gb(Y1,X1,tk+a1*h,daetype,parameter);
F1 = [f1 , f2 , f3];
[f1,f2,f3] = radauIIA_fdae_gb(Y2,X2,tk+a2*h,daetype,parameter);
F2 = [f1 , f2 , f3];
FF = [F1 F2];
end
