% Programm 5.6 reelle Fourier-Analyse
% input:  k=2n diskrete Funktionswerte einer periodischen Funktion
%         y_1, y_2,...,y_k
% output: reelle Fourierkoeffizienten a_0,a_1,...,a_n, b_0,b_1,...,b_n
%         b_0 = b_n =0 dummy-Werte
% Aufruf: [a,b] = rfft_gb(y);
function [a,b] = rfft_gb(y);
k = length(y); n=k/2;
if (2*floor(k/2) ~= k)
   disp('ungerade Zahl von Funktionswerten');
   return;
end
for k=1:n
   z(k)=y(2*k-1)+i*y(2*k);
end
% Bestimmung der komplexen Fourierkoeffizienten
c = fft(z);
c(n+1)=c(1);
% Berechnung der reellen Fourierkoeffizienten
for k=1:n+1
   ck = c(k); cck = conj(c(n+2-k));
   ab(k)=0.5*(ck+cck)-0.5*i*(ck-cck)*exp(-i*(k-1)*pi/n);
end
for k=1:n+1
   a(k)=real(ab(k))/n;
   if (k == 1 || k == n+1)
      b(k)=0;
   end
   b(k)=-imag(ab(k))/n;
end
end
