% Programm 9.2 zur Loesung eines nichtlin. Randwertproblems (rwp2nl_gb.m) 
% -lambda*y'' + sigma*y^4 = 0; y(a)=y0, -lambda*y'(b)=q
% input:  lambda, sigma, Intervallgrenzen a,b, Randwerte y0, q, Stuetzst.zahl n
% output: Loesung y(x) an den Stellen x
% Benutzung der Programme jacobirwp, gleichungrwp
% z.B. lambda = 1; sigma = 5.0e-06; a = 0; b =1; y0 = 150; q = 20; n = 20;
% Aufruf: [y,x] = rwp2nl_gb1(lambda,sigma,a,b,y0,q,n);
function [y,x] = rwp2nl_gb1(lambda,sigma,a,b,y0,q,n);
h = (b-a)/n; sigma0=0;
x = linspace(a+h/2,a+h*n-3*h/2,n-1);
y=zeros(n-1,1);
% Aufbau der Jacobi-Matrix
jm = jacobirwp(y,y0,n,h,lambda,sigma0);
% Aufbau der Gleichungen
grwp = gleichungrwp(y,y0,n,h,lambda,sigma0,q);
% Berechnung der Startiteration = ein Newtonschritt
% fuer das benachbarte lineare Problem
y = -jm\grwp; 
def = 1; it = 0;
% Newtoniteration
while (def > 1.0e-06 && it < 10)
  jm = jacobirwp(y,y0,n,h,lambda,sigma);
  grwp = gleichungrwp(y,y0,n,h,lambda,sigma,q);
  z = -jm\grwp; yn = y + z;
  def = norm(z)
  it = it+1
  y = yn;
end
end
