% Programm 8.4 zur Loesung eines Zweipunkt-Randwertproblmes (rwp2p2_gb.m)
% -(la(x)y')' + k(x)y = c(x),\; y'(a)=eta0, y(b)=eta1
% vorzugeben: a, b, eta0, eta1, n
% input:  Intervallgrenzen a,b, Randwerte eta0, eta1, n=(b-a)/h
% output: Loesung yy(x) an den Stellen x
% Benutzung der Programme tridia (Programm 2.4), la, k, c
% z.B. a = 0; b = 8; eta0 = 0; eta1 = -1.749; n = 200;
% Aufruf: [yy,x] = rwp2p2_gb2(a,b,eta0,eta1,n);
function [yy,x] = rwp2p2_gb2(a,b,eta0,eta1,n);
h = (b-a)/n;
x = linspace(a,b,n+1);
xp = (x(1:end-1)+x(2:end))/2;
dxp=x(2:end)-x(1:end-1);
dx=xp(2:end)-xp(1:end-1);
vla = la(xp);
vk = k(x);
vc = c(x);
% Aufbau der Matrix und der rechten Seite
dd(1) = vla(2)/(dxp(2)*dx(1))+vk(2);
cc(1) = 0;
dd(2:n-1) = vla(3:n)./(dxp(3:n).*dx(2:n-1))+vla(2:n-1)./(dxp(2:n-1).*dx(2:n-1))+vk(3:n);
cc(2:n-1) = vla(2:n-1)./(dxp(2:n-1).*dx(2:n-1));
ee(1:n-2) = vla(2:n-1)./(dxp(2:n-1).*dx(1:n-2));
ee(n-1) = 0; 
bb(1) = vc(2)+eta0*vla(1)/dx(1);
bb(2:n-2) = vc(3:n-1);
bb(n-1) = vc(n)+eta1*vla(n)/(dxp(n)*dx(n-1));
% Loesung
y = tridia_gb(cc,dd,ee,bb,n-1);
yy(1) = y(1)-dxp(1)*eta0;
yy(2:n) = y(1:n-1);
yy(n+1) = eta1;
end
