% Programm 5.5a zur Bestimmung der 2. Ableitungen
function [ys] = splabl1(x,y,n);
% Interpolation mit echten Splines/Bestimmung der Ableitungen ***
% Benutzung von tridia (Programm 2.4): -c xi-1 + d xi -e xi+1 = b ***
ys(1:n-1) = x(2:n) - x(1:n-1);
c(1:n-2) = -ys(1:n-2);
d(1:n-2) = 2*(ys(1:n-2)+ys(2:n-1));
e(1:n-2) = -ys(2:n-1);
c(1)=0.0; e(n-2)=0.0;
b(1:n-2) = 6*((y(3:n)-y(2:n-1))./ys(2:n-1) - (y(2:n-1)-y(1:n-2))./ys(1:n-2));
% *** Bestimmung der Ableitungen ys(1)...ys(n)
[xs] = tridia_gb(c,d,e,b,n-2);
ys(1)=0;
ys(n)=0;
ys(2:n-1) = xs(1:n-2);
end

% Programm 5.5b zur Berechnung 
% eines Funktionswertes eines kubischen Splines
function [splinew] = splber(z,x,y,ys,n)
% wobei x(1) <= z <= x(n) vorausgesetzt wird
i=1;
while (x(i) > z | z > x(i+1))
   i=i+1;
end
iz=i;
h=x(iz+1)-x(iz);
z1=z-x(iz);
a0=y(iz);
a1=(y(iz+1)-y(iz))/h - h*(2*ys(iz)+ys(iz+1))/6;
a2=ys(iz)/2;
a3=(ys(iz+1)-ys(iz))/(6*h);
splinew = a0+(a1+(a2+a3*z1)*z1)*z1;
end

% Programm 5.5 zur Berechnung eines kubischen Splines
% Berechnung des Wertes s(xx) eines kubischen Splines
% fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
% input:  Vektoren x(1:n), y(1:n), Stelle xx
% output: Wert des Splines s(xx)
% berechnet wird ein interpolierender Spline
% benutzte Funktionen: splabl, splber
% aufruf: fwert = spline_gb1(xx,x,y);
function [fwert] = spline_gb1(xx,x,y);
n=length(x);
ys = splabl1(x,y,n);
fwert = splber(xx,x,y,ys,n);
end
