% Programm 7.3 zum SQP-Verfahren (sqp_gb.m)
% Min F(x,y) , u.d.N. G(x,y) = 0
%
% F, G, gradF und gradG sind als Programme (Function)
% Spaltenvektoren, bereitzustellen
% input:  Startwert (x0,y0,lambda0), Lagrange-Multiplikator 
% output: Loesung (x*,y*,lambda*), F(x*,y*) und G(x*,y*)
% Aufruf: [xs,ys,lambda,f,g] = sqp_gb(x0,y0,lambda0)
% 
function [xs,ys,lambdas,f,g] = sqp_gb(x0,y0,lambda0)
M = zeros(3,3);
x = x0; y = y0; lambda = lambda0;
B = [2*lambda , 1 ; 1 , 2*lambda];
M = [ B , gradG(x,y); gradG(x,y)', 0];
rhs = [-gradF(x,y)-lambda*gradG(x,y) ; -G(x,y)];
%
epsilon = 0.0001;
k = 0;
while abs(G(x,y)) > epsilon  &&  k < 20
   k = k + 1
   X = M\rhs;
   dx = X(1); dy = X(2); dlambda = X(3);
   x = x + dx; y = y + dy; lambda = lambda + dlambda;
   B = [2*lambda , 1 ; 1 , 2*lambda];
   M = [ B , gradG(x,y); gradG(x,y)' , 0];
   rhs = [-gradF(x,y)-lambda*gradG(x,y) ; -G(x,y)];
end
xs = x;
ys = y;
lambdas = lambda;
f= F(x,y);
g = G(x,y);
end
