t0 = 0.0; % Anfangszeitpunkt
tf = 4.0; % Endzeitpunkt
h = 1e-1; % Schrittweite
x0 = [1.0 1.0]; % Anfangswert
eta = -0.27; % Parameter der DAE

% Berechnung der Lösung mit dem 2-stufigen Radau-IIA-Verfahren
% in der klassischen Formulierung f(x',x,t)=0
[x_classic, t_classic] = radauIIA_dae(t0,tf,x0,h,'classic',eta);

% Berechnung der Lösung mit dem 2-stufigen Radau-IIA-Verfahren
% in der Formulierung f((d(x,t))',x,t)=0 mit proper formuliertem
% Ableitungsterm (ker(f_y) oplus im(d_x))
[x_proper, t_proper] = radauIIA_dae(t0,tf,x0,h,'proper',eta);

plot(t_proper,x_proper(:,2)) % Plot der zweiten Komponente der Lösung x
hold
plot(t_classic,x_classic(:,2))