% Programm 2.4 zur Loesung 
% eines tridiagonalen linearen Gleichungssystems
%   -pc(k)*yps(k-1)+pd(k)*yps(k)-pe(k)*yps(k+1)=pf(k),k=1,n
% mit einer schwach diagonal dominanten Koeffizientenmatrix!
% input:
%   n - Dimension des Gleichungssystems
%   pc, pd, pe - Vektoren der Dimension l der tridiag. Matrix
%   pf         - Vektor der rechten Seiten
%   pc(1) und pe(n) sind dummy-Elemente
% output
%   yps        - Ergebnisvektor
% c und d sind Hilfsfelder
% aufruf: yps = tridia_gb(pc,pd,pe,pf,n);
function [yps]= tridia_gb(pc,pd,pe,pf,n);
c(1) = pe(1)/pd(1);
for i=2:n-1
	c(i) = pe(i)/(pd(i) - c(i-1)*pc(i));
end
d(1) = pf(1)/pd(1);
for i=2:n
	d(i) = (pf(i) + d(i-1)*pc(i))/(pd(i) - c(i-1)*pc(i));
end
yps(n) = d(n);
for i=n-1:-1:1
	yps(i) = d(i) + c(i)*yps(i+1);
end
end
