% Programm 10.2: weak_wiener_gb.m , schwache Approximation von W 
% Schwache Approximation von W 
%
% Wiener-Prozess ueber [0,1] (dt = 2^(-10)).
% schwache Approximation auf Gitter mit Dt = R*dt
randn('state',100) % random seeding
Wzero = 0 ; T = 1 ; N = 2^10 ; dt = 1/N;
dW = zeros(1,N); W = zeros(1,N); % Pre-Allokierung
dW = sqrt(dt)*randn(1,N) ; % Inkremente
W = cumsum(dW) ; % Wiener-Prozess
Xtrue = W ;
plot([0:dt:T],[Wzero,W],'g-'), hold on
R = 4 ; Dt = R*dt ; L = N/R; % L Zeitschritte der schwachen Approximation Dt = R*dt
WA = zeros(1,L) ; % Pre-Allokierung
Wtemp = Wzero ;
for j = 1:L
   Winc =  sum(dW(R*(j-1)+1:R*j)) ;
   Wtemp = Wtemp + sqrt(Dt)*sign(Winc) ;
   WA(j) = Wtemp ;
end
plot([0:Dt:T],[Wzero,WA],'r--*'), hold off
xlabel('t','FontSize',16)
ylabel('W','FontSize',16)
% Programmende
